from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5 import uic
from libnam import files, control, process
import importlib, hashlib
from importlib import reload
from libabr import core, file,res

from PyQt5 import QtCore, QtGui, QtWidgets

class MainApp (QMainWindow):
    fontsize = control.read_record("fontsize", "/etc/gui") # Get font size
    model = control.read_record("model", "/etc/gui") # Get screen model
    locale = control.read_record("locale","/etc/gui") # Get locale
    username = files.readall("/tmp/username.tmp") # Get username
    def suspend_act(self):
        import suspendpage
        w1 = suspendpage.w
        importlib.reload(suspendpage) ##https://www.geeksforgeeks.org/reloading-modules-python/
    def escape_act(self):
        core.shutdown()
        exit(0)
    def restart_act(self):
        core.reboot()
        exit(0)

    def desktop(self):
        self.close()
        import desktop
        w1 = desktop.w

    def check_password(self):
        self.password = self.lePassword.text()

        self.hashcode = hashlib.sha3_512(
            str(self.password).encode()).hexdigest()

        self.code = control.read_record("code", "/etc/users/" + self.username)

        if self.hashcode == self.code:
            files.create("/tmp/su.tmp")
            control.write_record("username", self.username.lower(), "/tmp/su.tmp")
            control.write_record("code", self.lePassword.text(), "/tmp/su.tmp")

            files.write("/proc/info/su", self.username)
            QTimer.singleShot(0,self.desktop)
        else:
            self.lblWrongpassword.setText(res.get("@string/lblWrongpassword"))
            QTimer.singleShot(1000, self.clear)

    ## Clear wrongs
    def clear(self):
        self.lblWrongpassword.clear()
        self.lePassword.clear()

    def __init__(self):
        super().__init__()

        ## Load ui ##
        uic.loadUi(res.get("@widget/enter"),self)

        ## Finds ##
        self.btnAccountImage = self.findChild(QPushButton,'btnAccountImage')
        self.lblPassword = self.findChild(QLabel, 'lblPassword')
        self.lblWrongpassword = self.findChild(QLabel,'lblWrongpassword')
        self.lePassword = self.findChild(QLineEdit, 'lePassword')
        self.menubar = self.findChild(QMenuBar,'menubar')
        self.menubar.setStyleSheet("background: none;")
        self.menuPower = self.findChild(QMenu,'menuPower')
        self.actionEscape = self.findChild(QAction,'actionEscape')
        self.actionRestart = self.findChild(QAction, 'actionRestart')
        self.actionSuspend = self.findChild(QAction, 'actionSuspend')

        ## Get locale controls ##

        ## Font Size configure ##
        if self.fontsize == None:
            self.fontsize = 12
        else:
            self.fontsize = int(self.fontsize)

        ## Set layout direction

        if res.get("@string/menubar_direction") == "rtl":
            self.menubar.setLayoutDirection(QtCore.Qt.RightToLeft)
        else:
            self.menubar.setLayoutDirection(QtCore.Qt.LeftToRight)

        ## Set locales all ##
        self.lblPassword.setText(res.get("@string/lblPassword").replace("{0}",self.username))
        self.menuPower.setTitle(res.get("@string/menu_power"))
        self.actionRestart.setText(res.get("@string/action_restart"))
        self.actionEscape.setText(res.get("@string/action_escape"))
        self.actionSuspend.setText(res.get("@string/action_suspend"))

        ## Set fonts all ##
        self.lblWrongpassword.setFont (QFont(res.get("@string/font"),self.fontsize))
        self.lblPassword.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.menubar.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.menuPower.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.actionSuspend.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.actionRestart.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.actionEscape.setFont(QFont(res.get("@string/font"), self.fontsize))
        self.lePassword.setFont(QFont(res.get("@string/font"), self.fontsize))

        ## Echo Password ##
        self.lePassword.setEchoMode (QtWidgets.QLineEdit.Password)

        ## Set Actions ##
        self.actionEscape.triggered.connect (self.escape_act)
        self.actionRestart.triggered.connect(self.restart_act)
        self.actionSuspend.triggered.connect(self.suspend_act)
        self.lePassword.returnPressed.connect(self.check_password) # https://pythonbasics.org/pyqt/ learn it

        ## Pyabr data
        self.cs = files.readall("/proc/info/cs")
        self.cd = files.readall("/proc/info/cd")
        self.ver = files.readall("/proc/info/ver")
        self.setWindowTitle(self.cs + " " + self.ver + " (" + self.cd + ")")

        ## Button Account Image
        self.userlogo = res.get(control.read_record("login.userlogo", "/etc/users/" + self.username))
        if self.userlogo == None:
            self.userlogo = res.get(control.read_record("login.userlogo", "/etc/gui"))

        round = self.btnAccountImage.width() / 2
        self.btnAccountImage.setStyleSheet("background-color: white;background-image: url(" +
            self.userlogo + ");color: white;border-radius: "+str(round)+"% "+str(round)+"%;border-style: solid;border-width: 1%;border-color: blue;")

        ## Default bgcolor check ##

        self.bgcolor = control.read_record("login.bgcolor", "/etc/users/" + self.username)
        if self.bgcolor == None:
            self.bgcolor = control.read_record("login.bgcolor", "/etc/gui")
        self.background = res.get(control.read_record("login.background", "/etc/users/" + self.username))
        if self.background == None:
            self.background = res.get(control.read_record("login.background", "/etc/gui"))

        if not self.bgcolor == None:
            self.setStyleSheet("background-color: " + self.bgcolor + ";")
        elif not self.background == None:
            self.setStyleSheet("background-image: url(" + self.background + ");")
        else:
            self.setStyleSheet("background-color: blue;")

        ## Frameless the window ##
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)

        ## Show default ##
        self.showFullScreen()


w = MainApp()