from PyQt5.QtWidgets import *
from PyQt5 import *
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from libnam import files, control, permissions
from libabr import core, file, res
import hashlib, importlib

from PyQt5 import QtCore, QtGui, QtWidgets, uic


class MainApp (QtWidgets.QMainWindow):
    model = control.read_record("model", "/etc/gui")
    fontsize = control.read_record("fontsize", "/etc/gui")
    username = files.readall("/tmp/username.tmp")

    def unlock(self):
        import unlock
        importlib.reload(unlock)
        w1 = unlock.w

    def unlock_act(self):
        self.close()
        if not self.username == "guest":
            self.unlock()

    def __init__(self):
        super().__init__()

        ## Load ui ##
        uic.loadUi(res.get("@widget/lock"), self)

        # Finds #
        self.btnUnlock = self.findChild(QtWidgets.QPushButton,'btnUnlock')

        ## Font Size configure ##
        if self.fontsize == None:
            self.fontsize = 12
        else:
            self.fontsize = int(self.fontsize)

        # Unlock action #
        self.btnUnlock.clicked.connect(self.unlock_act)

        ## Get distro database
        self.cs = files.readall("/proc/info/cs")
        self.cd = files.readall("/proc/info/cd")
        self.ver = files.readall("/proc/info/ver")
        self.setWindowTitle(self.cs + " " + self.ver + " (" + self.cd + ")")

        ## Default bgcolor check ##
        self.bgcolor = None
        if not self.username == "guest":
            self.bgcolor = control.read_record("unlock.bgcolor", "/etc/users/" + self.username)
        if self.bgcolor == None:
            self.bgcolor = control.read_record("unlock.bgcolor", "/etc/gui")
        self.background = None
        if not self.username == "guest":
            self.background = res.get(control.read_record("unlock.background", "/etc/users/" + self.username))
        if self.background == None:
            self.background = res.get(control.read_record("unlock.background", "/etc/gui"))

        if not self.bgcolor == None:
            self.btnUnlock.setStyleSheet("background-color: " + self.bgcolor + ";")
        elif not self.background == None:
            self.btnUnlock.setStyleSheet("background-image: url(" + self.background + ");")
        else:
            self.btnUnlock.setStyleSheet("background-color: blue;")

        ## Frameless the window ##
        self.setWindowFlags(QtCore.Qt.FramelessWindowHint)

        ## Show lock ##
        self.showFullScreen()



w = MainApp()