## Upgrade the clouding system ##

from libnam import control, files, colors, permissions
import git, wget,shutil
from libabr import core, archive

## Check root ##
if not permissions.check_root (files.readall("/proc/info/su")):
    colors.show ("upgrade","perm","")
    exit(0)

upgrade_mirror = control.read_record ('upgrade-mirror','/etc/repo')
upgrade_distro = control.read_record('upgrade-distro','/etc/repo')

## Check nulls ##
if upgrade_mirror==None or upgrade_mirror=='' or upgrade_mirror==" ":
    colors.show ("upgrade","fail","cannot upgrade system; upgrade mirror record is null.")
    exit()
if upgrade_distro==None or upgrade_distro=='' or upgrade_distro==" ":
    colors.show ("upgrade","fail","cannot upgrade system; upgrade distro record is null.")
    exit()

distro = wget.download(upgrade_distro) # Download this file
shutil.copyfile(distro,files.input('/tmp/'+distro))

version = control.read_record('version','/tmp/'+distro)
this_version = control.read_record('version','/etc/distro')

## Check version ##
if not version==this_version:
    ## Get backups ##
    archive.zip ('/etc','/app/backups/etc')

    ## Get packages ##
    colors.show("", "ok", "\nGet the lates version of Pyabr "+version+" ...")
    git.Git(files.input("/tmp/")).clone(
        upgrade_mirror)  # Get the lates release of this clouding system ([/etc/repo]: upgrade-mirror)

    ## Install Upgrades ##
    colors.show("","ok","Install upgrade packages ...")
    core.system("saye /tmp/pyabr/upgrade.sa")  # Run this script

    ## Unpack backups ##
    shutil.unpack_archive(files.input('/app/backups/etc.zip'),files.input('/etc'),'zip')
    files.cut ('/distro','/etc/distro')

    if input("Upgrading the Pyabr was completed, Do you want to reboot the system? (Y/n): ").lower ()=='y':
        core.system("reboot")
else:
    print ("Pyabr has already up to date.")